<?php
/**
* @version		1.0.0 techfolio $
 * @package		techfolio
 * @copyright	Copyright © 2011 - All rights reserved.
 * @license		GNU/GPL
 * @author		shivanshu
 * @author mail	info@techdeluge.com
 * @website		techdeluge.com
 *
 *
 * @MVC architecture generated by MVC generator tool at http://www.alphaplug.com
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.model' );

class techfolioModelTechfolio extends Jmodel
{
	var $_data = null;
	var $_total = null;
	var $_pagination = null;
	
	
	function __construct(){
		parent::__construct();
		
		global $mainframe;
		
		$context			= 'com_techfolio.techfolio.list.';
	
		// Get the pagination request variables
		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( $context.'limitstart', 'limitstart', 0, 'int' );
		
		// In case limit has been changed, adjust limitstart accordingly
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
		
		
	}

	/**
	 * Get list of record
	 *
	 * @return array
	 */
	function getData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			
			$query = $this->_buildQuery();			
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}
		
		return $this->_data;
	}

	/**
	 * Return number of total record
	 *
	 * @return int
	 */
	function getTotal()
	{
		// Lets load the content if it doesn't already exist
	
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}

	/**
	 * Pagination object
	 *
	 * @return object
	 */
	function getPagination()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}

	/**
	 * Buid query
	 *
	 * @return String
	 */
	
	function _buildQuery()
	{
		// Get the WHERE and ORDER BY clauses for the query
		$where		= $this->_buildContentWhere();
		$orderby	= $this->_buildContentOrderBy();

		/*$query = 'SELECT e.*,c.title,e.catid FROM #__estock e
				  LEFT JOIN #__categories c ON e.catid=c.id';*/
				
		$query = 'SELECT * FROM #__techfolio As c';	
				 	  
		$query .= $where;		  
		$query .= $orderby;		  
		return $query;
		
	}
	
	

	/**
	 * Build order by for query
	 *
	 * @return String
	 */
	function _buildContentOrderBy()
	{
		global $mainframe;
		$context			= 'com_techfolio.techfolio.list.';
		
		$filter_order		= $mainframe->getUserStateFromRequest( $context.'filter_order',		'filter_order',		'id',	'cmd' );		
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $context.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		if($filter_order=='catid')
		{
			$filter_order = ' catid,ordering';
		}
		
		$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.'';
		
		return $orderby;
	}

	/**
	 * Build where for query
	 *
	 * @return String
	 */
	function _buildContentWhere()
	{
		global $mainframe;
		$context			= 'com_techfolio.techfolio.list.';
		$db = &JFactory::getDBO();
		
		$search	= $mainframe->getUserStateFromRequest( $context.'search','search','','string' );		
		//$catid	= $mainframe->getUserStateFromRequest( $context.'catid','catid','','int' );
		$filter_state	= $mainframe->getUserStateFromRequest( $context.'filter_state','filter_state','','string' );
		
		
		
		$where = array();

		
		if (strpos($search, '"') !== false) {
			$search = str_replace(array('=', '<'), '', $search);
		}
		
		$search = JString::strtolower($search);
		
		if (isset( $search ) && $search!= '')
		{
			$searchEscaped = $db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			$where[] = 'c.headline  LIKE '.$searchEscaped;
		}
		//-------------added by harsh[end]-------------------------------
		
		if ($catid) {
			$where[] = ' catid='.$catid ;
		}
		if ( $filter_state )
		{
			if ( $filter_state == 'P' ) {
				$where[] = '  c.published = 1';
			}
			else if ($filter_state == 'U' ) {
				$where[] = ' c.published = 0';
			}
		}
		
		

		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );
		
		
		return $where;
	}

	/**
	 * Save order of item
	 *
	 * @param array $cid
	 * @param int $order
	 * @return boolean
	 */
	function saveorder($cid = array(), $order) {
		$row =& $this->getTable("addtechfolio");
		$groupings = array();

		// update ordering values
		for( $i=0; $i < count($cid); $i++ )
		{
			$row->load( (int) $cid[$i] );
			// track categories
			$groupings[] = $row->catid;

			if ($row->ordering != $order[$i])
			{
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}

		// execute updateOrder for each parent group
		$groupings = array_unique( $groupings );
		foreach ($groupings as $group){
			$row->reorder('catid = '.(int) $group);
		}
		return true;
	}
	
	/**
	 * Move order up and down
	 *
	 * @param order
	 * @return boolean
	 */
	function move($direction) {
	
		$row =& $this->getTable("addtechfolio");
		$cid = JRequest::getVar("cid");
		
		if (!$row->load($cid[0])) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}		
		

		if (!$row->move( $direction)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		return true;
	}
	
	/**
	 * update status for publish and unpublish
	 *
	 * @param boolean $state
	 * @return boolean
	 */
	function publish($state) {
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
	    $row =& $this->getTable("techfolio");
	
	        if (!$row->publish( $cids, $state )) {
	            $this->setError( $row->getError() );
	            return false;
	        }
	
	    return true;
	}
	
	/**
	 * Delete record from database
	 *
	 * @return boolean
	 */
	function delete()
	{
	    $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_techfolio'.DS.'tables');
	    $row =& $this->getTable("techfolio");
	
	    foreach($cids as $cid) {
	        if (!$row->delete( $cid )) {
	            $this->setError( $row->_db->getErrorMsg() );
	            return false;
	        }
	    }
	
	    return true;
	}
	
	
}
?>